<?php

function contact_form()
{
	$CONTACT = new Contact;
	$CONTACT->output();
}

class Contact_form
{
	// CHANGE THE TO AND SUBJECT
	var $to      	= 'vaska@indexhibit.org';
	var $subject 	= 'From your website';

	var $active 	= false;
	var $spam 		= false;
	var $valid 		= false;
	var $errors 	= array();
	var $email;
	var $message;
	var $html;

	function Contact_form()
	{
		if (isset($_POST['submitted']) && isset($_POST['contacted']))
		{
			$this->active = true;
			
			// is real email address
			$this->email = $_POST['contacted']['email'];
			$this->is_email_address();
			
			// simple check for spambot
			if ($_POST['botted'] != '') $this->spam = true;
		}
	}
	
	function the_form()
	{
		$html = "<form method='POST' action='' id='contact-form'>\n";
		$html .= "<div><label>Email Address</label><br />\n";
		$html .= "<input type='text' name='contacted[email]' style='width: 300px;' /></div>\n";
		$html .= "<div><label>Message</label><br />\n";
		$html .= "<textarea name='contacted[msg]' style='width: 300px; height: 56px;'></textarea></div>\n";
		$html .= "<div><input type='submit' name='submitted' class='a-submit' />\n";
		$html .= "<input type='hidden' name='botted' value='' /></div>\n";
		$html .= "</form>\n";
		
		return $html;
	}
	
	function is_spam_message()
	{
		return "<p>This appears to be spam.</p>";
	}
	
	function is_not_valid_email()
	{
		return "<p>This is not a valid email address.</p>";
	}
	
	function thank_you_message()
	{
		return "<p>Thanks for the note, I will respond as soon as I can.</p>";
	}
	
	function output()
	{
		if ($this->active == false)
		{
			return $this->the_form();
		}
		else
		{
			if ($this->spam == true)
			{
				return $this->is_spam_message();
			}
			else
			{
				// is valid email address
				if ($this->valid == true)
				{
					// validate inputs / make sure they aren't harmful
					if (isset($_POST['contacted']['msg']))
					{
						$message = strip_tags($_POST['contacted']['msg']);
						$message = $this->strip_bbcode($message);
					}
					else
					{
						$message = $this->email;
					}
				
					// headers
					$headers = 'From: ' . $this->email . "\r\n";
					$headers .= 'X-Mailer: PHP/' . phpversion() . "\r\n";
					$headers .= 'MIME-Version: 1.0' . "\r\n";
					$headers .= 'Content-type: text/plain; charset=UTF-8' . "\r\n";

					// send mail
					mail($this->to, $this->subject, $message, $headers);
				
					// return thank you note
					return $this->thank_you_message();
				}
				else // not a real email address
				{
					$html = $this->is_not_valid_email();
					$html .= $this->the_form();
					
					return $html;
				}
			}
		}
	}
	
	function strip_bbcode($text_to_search) 
	{
		$pattern = '|[[\/\!]*?[^\[\]]*?]|si';
		$replace = '';
		return preg_replace($pattern, $replace, $text_to_search);
	}
	
	function is_email_address()
	{
		$pattern = '/^([a-z0-9])(([-a-z0-9._])*([a-z0-9]))*\@([a-z0-9])' .
		'(([a-z0-9-])*([a-z0-9]))+' . '(\.([a-z0-9])([-a-z0-9_-])?([a-z0-9])+)+$/i';

		if (preg_match($pattern, $this->email)) $this->valid = true;
	}
}